Subject: Re: r8169 MAC addresses broken

From: Ivan Vecera <[email-masked]>
Date: Tue, 04 Nov 2008 19:49:42 +0100

Jiri Slaby wrote:
> On 11/03/2008 10:04 AM, Ivan Vecera wrote:
>> Jiri Slaby wrote:
>>> On 10/28/2008 02:45 PM, Krzysztof Halasa wrote:
>>>> Jiri Slaby <[email-masked]> writes:
>>>>
>>>>>> Same thing if you unplug the battery ?
>>>>> Thanks, now it seems to be OK.
>>>> Well, perhaps reverting that patch was a bit premature?
>>> No, it helped after reverting that patch. I think we don't want defunct 2.6.28
>>> with these nics.
>> I cannot agree.
> 
> You want defunct r8169 in 2.6.28? Or cannot agree with what?
> 
>> IMO the problem was in the first version of the patch that didn't
>> check for invalid (zeroed) MAC address. In this case is necessary to power-off (desktop
>> case) or unplug the battery (notebook case).
> 
> I see no updated patch in this thread to test -- am I missing something?
Francois has fix for this problem (zeroed MAC address) in his repository:
http://git.kernel.org/?p=linux/kernel/git/romieu/netdev-2.6.git;a=commitdiff;h=9b1abbccf53ef1a1213b159d56257b535c599f07

snippet:
...
-       /* Write MAC address */
-       rtl_rar_set(tp, mac);
+       if (is_valid_ether_addr(mac))
+               rtl_rar_set(tp, mac);
...

When MAC only zeros then it is not assigned. Pulling this commit is better than reverting whole patch.

Ivan